#ifndef __TIMING_H__
#define __TIMING_H__

#define MAX_DESCRIPTION_LENGTH 50

typedef enum {
	TIMING_ALL = 0,
	TIMING_INIT,
	TIMING_READ_ATOM_CONFIG,
	TIMING_LOOPS,
	TIMING_MD_STEP,
	TIMING_ATOM_COPY,
	TIMING_ATOM_MOVE,
	TIMING_FORCE_RETURN,
	TIMING_COMPUTE_ACCEL,
	TIMING_COMPUTE_ACCEL_2B,
	TIMING_COMPUTE_ACCEL_3B,
	TIMING_ANALYSIS,
	TIMING_ANALYSIS_COLLECTION,
	TIMING_WRITE_OUTPUT_XYZ,
	TIMING_WRITE_OUTPUT_MTS,
	TIMING_WRITE_OUTPUT_ATOMIC_FORCE,
	TIMING_REORDERING,
	TIMING_BARRIER0,
	TIMING_BARRIER1,
	TIMING_BUILD_NEIGHBOR_LIST,
	TIMING_COMPUTE_ACCEL_2B_THREAD,
	TIMING_COMPUTE_ACCEL_3B_THREAD,
	TIMING_COMPUTE_ACCEL_2B_GPU,
	TIMING_COMPUTE_ACCEL_3B_GPU,
	TIMING_COMPUTE_ACCEL_2B_MIC,
	TIMING_COMPUTE_ACCEL_3B_MIC,

	TIMING_SECTIONS_MAX //put this at last to define number of TIMING_SECTIONs
} TIMING_SECTIONS;

typedef struct elapse_timer_st {
	int	root;
	int	isStart;
	long	count;
	double  startMark;
	double	sumInterval;
	double 	sumInterval2;
	double  sumChildren;
	char	description[MAX_DESCRIPTION_LENGTH];
	int	children[TIMING_SECTIONS_MAX+1];
} ELAPSE_TIMER;


void timerInit();
void timerStart(TIMING_SECTIONS ts);
void timerStop(TIMING_SECTIONS ts);
void forceTimingRelation(TIMING_SECTIONS tsChild, TIMING_SECTIONS tsParent);
void timerWriteProfile();
void resetTimer_collection();


#endif

